import React, { useState, useEffect } from 'react';
import { Modal, Form, Input, Button,  Switch,InputNumber } from 'antd';

const CreateForm = (props) => {
  return (
    <Modal
      title={props.values.id ? '编辑' : '新建'}
      width={640}
      visible={props.createModalVisible}
      bodyStyle={{ padding: '32px 40px 48px' }}
      footer={null}
      onCancel={() => {
        props.onCancel();
      }}
      destroyOnClose
    >
      <Form
        layout="vertical"
        preserve={false}
        initialValues={props.values}
        onFinish={props.onFinish}
      >
        <Form.Item name="id" hidden={true}>
          <Input />
        </Form.Item>
        <Form.Item name="status" hidden={true}>
          <Input />
        </Form.Item>
        <Form.Item name="name" label="工序名称" rules={[{ required: true, max: 64, whitespace: true }]}>
          <Input placeholder="请输入工序名称" />
        </Form.Item>
        <Form.Item name="remark" label="工序描述" rules={[{ required: true, max: 64, whitespace: true }]}>
          <Input placeholder="请输入工序描述" />
        </Form.Item>
        <Form.Item>
          <Button type="primary" htmlType="submit">
            保存
          </Button>
        </Form.Item>
      </Form>
    </Modal>
  );
};

export default CreateForm;
