import React from 'react';
import { Input, Modal, Form, Select, Button, InputNumber } from 'antd';

const CreateForm = (props) => {
  const { Option, OptGroup } = Select;
  const { TextArea } = Input;
  return (
    <Modal
      title={props.values.id ? '编辑' : '新建'}
      width={640}
      visible={props.createModalVisible}
      bodyStyle={{ padding: '32px 40px 48px' }}
      footer={null}
      onCancel={() => {
        props.onCancel();
      }}
      destroyOnClose
      maskClosable={false}
    >
      <Form
        layout="vertical"
        preserve={false}
        initialValues={props.values}
        onFinish={props.onFinish}
      >
        <Form.Item name="id" hidden={true}>
          <Input />
        </Form.Item>
        <Form.Item name="code" label="字典类型编码" rules={[{ required: true, max: 65 }]}>
          <Input placeholder="请输入字典类型编码" />
        </Form.Item>
        <Form.Item name="name" label="字典类型名称" rules={[{ required: true, max: 65 }]}>
          <Input placeholder="请输入字典类型名称" />
        </Form.Item>
        <Form.Item
          name="sort"
          label="字典类型排序"
          rules={[{ required: true, message: '请选择字典类型排序!' }]}
        >
          <InputNumber min={1} decimalSeparator="0" />
        </Form.Item>
        <Form.Item
          name="status"
          label="字典类型状态"
          defaultValue={props.values.status}
          rules={[{ required: true, message: '请选择字典类型状态' }]}
        >
          <Select placeholder="请选择字典类型状态">
            <OptGroup>
              <Select.Option value="0">正常</Select.Option>
              <Select.Option value="1">停用</Select.Option>
            </OptGroup>
          </Select>
        </Form.Item>
        <Form.Item name="remark" label="字典类型备注" rules={[{ required: true, max: 500 }]}>
          <TextArea rows={4} placeholder="请输入字典类型备注" />
        </Form.Item>
        <Form.Item>
          <Button type="primary" htmlType="submit">
            保存
          </Button>
        </Form.Item>
      </Form>
    </Modal>
  );
};

export default CreateForm;
